import { Block, useActionPopup } from '@ensi-platform/core-components';
import { useRouter } from 'next/router';
import { useCallback, useMemo, useState } from 'react';

import {
    CategoriesFilter,
    Category,
    CategoryTreeItem,
    useCategories,
    useCategoriesMeta,
    useCategoriesTree,
    useCategoryDelete,
} from '@api/catalog';

import { useError, useSuccess } from '@context/modal';

import { initialSort } from '@views/logistic/pickup-points/[id]/scripts/constants';

import AutoFilters from '@components/AutoFilters';
import PageWrapper from '@components/PageWrapper';
import Table, { ExtendedRow, TooltipItem, TrProps, useSorting, useTable } from '@components/Table';
import { getSettingsColumn } from '@components/Table/columns';
import { RowTooltipWrapper, TableEmpty, TableFooter, TableHeader } from '@components/Table/components';

import { ModalMessages } from '@scripts/constants';
import { Button, Layout, scale, typography } from '@scripts/gds';
import { declOfNum, getTotal, getTotalPages } from '@scripts/helpers';
import { useLinkCSS, useRedirectToNotEmptyPage, useTableList } from '@scripts/hooks';
import { useAutoColumns, useAutoFilters, useAutoTableData } from '@scripts/hooks/autoTable';
import { useGoToDetailPage } from '@scripts/hooks/useGoToDetailPage';

import ChevronDown from '@icons/small/chevronDown.svg';
import PlusIcon from '@icons/small/plus.svg';

import TreeChildren from './TreeChildren';
import useCategoriesAccess from './useCategoriesAccess';

export default function ProductCategories() {
    const { push, pathname } = useRouter();

    const { access } = useCategoriesAccess();

    const {
        LIST: { view: canViewListingAndFilters },
        ID: { view: canViewDetailPage, create: canCreateCategory, delete: canDeleteCategory },
    } = access;

    const { popupState, popupDispatch, ActionPopup, ActionEnum, ActionType } = useActionPopup();

    const goToDetailPage = useGoToDetailPage();

    const deleteCategory = useCategoryDelete();

    const onDeleteCategory = useCallback((originalRows: ExtendedRow['original'][] | undefined) => {
        if (originalRows) {
            popupDispatch({
                type: ActionType.Delete,
                payload: {
                    title: 'Удалить категорию?',
                    popupAction: ActionEnum.DELETE,
                    onAction: async () => {
                        await deleteCategory?.mutateAsync(originalRows[0].original.id);
                    },
                },
            });
        }
    }, []);

    const tooltipContent: TooltipItem[] = useMemo(
        () => [
            {
                type: 'edit',
                text: 'Редактировать категорию',
                action: goToDetailPage,
                isDisable: !canViewDetailPage,
            },
            {
                type: 'delete',
                text: 'Удалить категорию',
                action: onDeleteCategory,
                isDisable: !canDeleteCategory,
            },
        ],
        [goToDetailPage, onDeleteCategory, canViewDetailPage, canDeleteCategory]
    );

    const blueLinkStyles = useLinkCSS('blue');
    const [isCategoriesExpanded, setCategoriesExpanded] = useState<boolean>(false);
    const toggle = () => setCategoriesExpanded(!isCategoriesExpanded);

    const { data: meta, isFetching: isMetaLoading, error: metaError } = useCategoriesMeta(canViewListingAndFilters);
    useError(metaError);
    const metaData = useMemo(() => meta?.data, [meta]);

    const {
        metaField,
        values,
        filtersActive,
        URLHelper,
        searchRequestFilter,
        emptyInitialValues,
        reset,
        codesToSortKeys,
        clearInitialValue,
    } = useAutoFilters(metaData);
    const [{ backendSorting }, sortingPlugin] = useSorting<CategoriesFilter>(pathname, metaData?.fields, initialSort);

    const { activePage, itemsPerPageCount, setItemsPerPageCount } = useTableList({
        defaultSort: metaData?.default_sort,
        codesToSortKeys,
    });

    const [selectedFilter, setSelectedFilter] = useState<CategoriesFilter>({});

    const {
        data: categories,
        isFetching: isCategoriesLoading,
        error: categoriesError,
    } = useCategories(
        {
            sort: backendSorting,
            filter: {
                ...searchRequestFilter,
                // в случае необходимости "перекрытия" фильтра из дерева категорий
                ...(selectedFilter?.id && { id: selectedFilter?.id }),
                ...(selectedFilter?.parent_id && { parent_id: selectedFilter?.parent_id, id: null }),
            },
            pagination: { type: 'offset', limit: itemsPerPageCount, offset: (activePage - 1) * itemsPerPageCount },
        },
        Boolean(meta) && !!backendSorting
    );
    useError(categoriesError);

    const categoriesTableData = useAutoTableData<Category>(categories?.data, metaField);

    const autoGeneratedColumns = useAutoColumns(metaData, canViewDetailPage);

    const columns = useMemo(
        () => [
            ...autoGeneratedColumns,
            getSettingsColumn({ columnsToDisable: [], visibleColumns: metaData?.default_list, tooltipContent }),
        ],
        [autoGeneratedColumns, metaData?.default_list]
    );

    const total = getTotal(categories);
    const totalPages = getTotalPages(categories, itemsPerPageCount);
    useRedirectToNotEmptyPage({ activePage, itemsPerPageCount, total });

    const renderHeader = useCallback(
        () => (
            <TableHeader>
                <div
                    css={{
                        display: 'flex',
                        alignItems: 'center',
                        justifyContent: 'space-between',
                        width: '100%',
                        padding: 0,
                    }}
                >
                    <p css={{ lineHeight: '32px', ...typography('bodySm') }}>
                        Найдено {`${total} ${declOfNum(total, ['категория', 'категории', 'категорий'])}`}
                    </p>
                    {canCreateCategory && (
                        <Button
                            Icon={PlusIcon}
                            theme="primary"
                            type="submit"
                            onClick={() => push(`${pathname}/create`)}
                        >
                            Создать категорию
                        </Button>
                    )}
                </div>
            </TableHeader>
        ),
        [total, pathname, push]
    );

    const {
        data: categoriesTree,
        isFetching: categoriesTreeLoading,
        error: categoriesTreeError,
    } = useCategoriesTree({}, Boolean(meta));
    useError(categoriesTreeError);

    useError(deleteCategory.error);
    useSuccess(deleteCategory.isSuccess ? ModalMessages.SUCCESS_DELETE : '');

    const handlerOnSelectCategory = ({ id, children }: { id: number; children: CategoryTreeItem[] }) => {
        if (children.length > 0) setSelectedFilter({ parent_id: id });
        else setSelectedFilter({ id });
    };

    const getTooltipForRow = useCallback(() => tooltipContent || [], [tooltipContent]);
    const renderRow = useCallback(
        ({ children, ...props }: TrProps<any>) => (
            <RowTooltipWrapper
                {...props}
                getTooltipForRow={getTooltipForRow}
                onDoubleClick={() => {
                    if (canViewDetailPage) push(`${pathname}/${props.row?.original[metaData?.detail_link || 'id']}`);
                }}
            >
                {children}
            </RowTooltipWrapper>
        ),
        [getTooltipForRow]
    );

    const table = useTable(
        {
            data: categoriesTableData,
            columns,
            meta: {
                tableKey: pathname,
            },
        },
        [sortingPlugin]
    );

    return (
        <PageWrapper
            h1={canViewListingAndFilters ? 'Категории' : ''}
            isLoading={isMetaLoading || isCategoriesLoading || categoriesTreeLoading || deleteCategory?.isPending}
        >
            {canViewListingAndFilters ? (
                <>
                    <AutoFilters
                        initialValues={values}
                        emptyInitialValues={emptyInitialValues}
                        onSubmit={URLHelper}
                        filtersActive={filtersActive}
                        css={{ marginBottom: scale(2) }}
                        meta={metaData}
                        onResetFilters={reset}
                        clearInitialValue={clearInitialValue}
                    />
                    <Layout cols={{ xxxl: 6, xs: 2 }}>
                        <Layout.Item col={{ xxxl: 2, xs: 2 }}>
                            <Block>
                                <Block.Body>
                                    <ul>
                                        <li>
                                            <button
                                                onClick={() => {
                                                    toggle();
                                                    setSelectedFilter({});
                                                    push({ query: {} });
                                                }}
                                                type="button"
                                                css={{ width: '100%', textAlign: 'left' }}
                                            >
                                                <span css={blueLinkStyles}>Все категории</span>{' '}
                                                <ChevronDown
                                                    css={{
                                                        verticalAlign: 'middle',
                                                        transition: 'transform 0.25s ease-in-out',
                                                        transform: isCategoriesExpanded ? 'rotate(180deg)' : 'none',
                                                    }}
                                                />
                                            </button>
                                        </li>

                                        {isCategoriesExpanded && (
                                            <TreeChildren
                                                childTree={categoriesTree?.data}
                                                onSelectCategory={handlerOnSelectCategory}
                                            />
                                        )}
                                    </ul>
                                </Block.Body>
                            </Block>
                        </Layout.Item>
                        <Layout.Item col={{ xxxl: 4, xs: 2 }}>
                            <Block>
                                <Block.Body>
                                    {renderHeader()}
                                    <Table instance={table} Tr={renderRow} />
                                    {categoriesTableData?.length === 0 && !isCategoriesLoading ? (
                                        <TableEmpty
                                            filtersActive={filtersActive}
                                            titleWithFilters="Категории не найдены"
                                            titleWithoutFilters="Категорий нет"
                                            addItems={() => setItemsPerPageCount(10)}
                                            onResetFilters={reset}
                                        />
                                    ) : (
                                        <TableFooter
                                            pages={totalPages}
                                            itemsPerPageCount={itemsPerPageCount}
                                            setItemsPerPageCount={setItemsPerPageCount}
                                            css={{ gridTemplateColumns: 'none' }}
                                        />
                                    )}
                                </Block.Body>
                            </Block>
                        </Layout.Item>
                    </Layout>

                    <ActionPopup popupState={popupState} popupDispatch={popupDispatch} />
                </>
            ) : (
                <h1 css={{ ...typography('h1'), textAlign: 'center' }}>
                    У вас недостаточно прав для просмотра списка категорий
                </h1>
            )}
        </PageWrapper>
    );
}
